<?php
   /*
     * $Id$
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     *                   David Morton <mortonda@dgrmm.net>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */

  function pre_check_4() {
    if (table_exists("maia_tokens")) {
      return array(false, "Already exists");
    } else {
      return array(true,"");
    }
  }
  
  function upgrade_4() {
    global $dbh;
    
    if (is_mysql()) {
        $sql_stmts = array(
                     "CREATE TABLE maia_tokens ( " .
                     "id INT UNSIGNED NOT NULL AUTO_INCREMENT, " .
                     "token_system VARCHAR( 32 ) NOT NULL, " . 
                     "token CHAR( 32 ) NOT NULL, " . 
                     "data BLOB NOT NULL, " .
                     "expires DATETIME NOT NULL, " .
                     "PRIMARY KEY ( id ), " .
                     "UNIQUE token ( token, token_system ), " . 
                     "INDEX token_system ( token_system ), " .
                     "INDEX expires (expires) " .
                     ") TYPE=InnoDB",
                     
                     "ALTER TABLE maia_mail_recipients ADD COLUMN token char(32)",
                     "ALTER TABLE maia_users ADD COLUMN quarantine_digest_interval int unsigned DEFAULT '0' NOT NULL",
                     "ALTER TABLE maia_users ADD COLUMN last_digest_sent datetime",
                     "UPDATE maia_mail_recipients set token = md5(CONCAT(NOW(),RAND())) where token = ''",
                     "ALTER TABLE maia_mail_recipients CHANGE token token CHAR( 32 ) NOT NULL",
                     "ALTER TABLE maia_mail_recipients ADD CONSTRAINT UNIQUE token_system_idx ( token )" 
                    );
    } else {
      $sql_stmts = array(
                     "CREATE TABLE maia_tokens (
                        id            SERIAL PRIMARY KEY,
                        token_system  VARCHAR( 32 ) NOT NULL ,
                        token         CHAR( 32 ) NOT NULL ,
                        data          bytea NOT NULL ,
                        expires       TIMESTAMP NOT NULL
                        )",
                     "CREATE UNIQUE INDEX token_system_key ON maia_tokens (token,token_system)",
                     "CREATE INDEX token_system ON maia_tokens ( token_system )",
                     "CREATE INDEX expires ON maia_tokens ( expires )",
                     
                     "ALTER TABLE maia_mail_recipients ADD COLUMN token char(32)",
                     "ALTER TABLE maia_users ADD COLUMN quarantine_digest_interval INTEGER DEFAULT '0' NOT NULL",
                     "ALTER TABLE maia_users ALTER quarantine_digest_interval SET DEFAULT '1'",
                     "UPDATE maia_users SET quarantine_digest_interval = '1'",
                     "ALTER TABLE maia_users ALTER quarantine_digest_interval SET NOT NULL",
                     "ALTER TABLE maia_users ADD COLUMN last_digest_sent TIMESTAMP",
                     "UPDATE maia_mail_recipients set token = md5(NOW() || RANDOM())",
                     "ALTER TABLE maia_mail_recipients ALTER token SET NOT NULL",
                     "CREATE INDEX token_idx ON maia_mail_recipients(token)" 
                     
                     
                   );
    }                
    foreach ($sql_stmts as $sql) {
       $result = $dbh->query($sql);
       if (PEAR::isError($result)) {
         $str = $result->getMessage() . " = [" . $sql . "]" ;
         /* return array(false, $result->getMessage()); */
         return array(false, $str );
       }
    }
    
    return array(true,"");
  }
  
  function post_check_4() {
    if (! column_exists("maia_users", "last_digest_sent")) {
      return array(false, "Error creating");
    } else {
      return array(true,"");
    }
    
  }
  
?>
