<?php
    /*
     * $Id: adminsystem.php 631 2005-05-03 19:19:22Z jleaver $
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */

    // Page subtitle
    $lang['banner_subtitle'] =  "Administration: System Configuration";

    // Table header
    $lang['header_system_menu'] =  "System Configuration";
    $lang['header_charts'] =  "Charts";
    $lang['header_reminders'] =  "Cache Expiry & Quarantine Reminders";
    $lang['header_authentication'] =  "Authentication";
    $lang['header_virus_info'] =  "Virus Information";
    $lang['header_display'] =  "Display";
    $lang['header_paths'] =  "Paths & Ports";
    $lang['header_bandwidth'] =  "Bandwidth Accounting";
    $lang['header_stats_reporting'] =  "Site Statistics Reporting";

    // Text labels
    $lang['text_yes'] =  "Yes";
    $lang['text_no'] =  "No";
    $lang['text_accept'] =  "Accepted";
    $lang['text_reject'] =  "Rejected";
    $lang['text_enable_user_autocreation'] =  "Enable auto-creation of user accounts?";
    $lang['text_internal_auth'] =  "Auto-issue passwords to new accounts?";
    $lang['text_enable_false_negative_management'] =  "Enable tracking of false negatives?";
    $lang['text_enable_stats_tracking'] =  "Enable tracking of statistics?";
    $lang['text_enable_virus_scanning'] =  "Enable virus scanning?";
    $lang['text_enable_spam_filtering'] =  "Enable spam filtering?";
    $lang['text_enable_banned_files_checking'] =  "Enable banned file attachment checks?";
    $lang['text_enable_bad_header_checking'] =  "Enable checks for invalid mail headers?";
    $lang['text_enable_spamtraps'] =  "Enable spam-trap accounts?";
    $lang['text_enable_charts'] =  "Enable graphical charts?";
    $lang['text_enable_address_linking'] =  "Allow users to link e-mail addresses to their accounts?";
    $lang['text_enable_username_changes'] =  "Allow users to change their usernames?";
    $lang['text_enable_privacy_invasion'] =  "Allow administrators to read users' mail?";
    $lang['text_system_default_user_is_local'] =  "Should the System Default user (@.) only catch mail for local recipients?";
    $lang['text_user_virus_scanning'] =  "Allow users to enable/disable virus scanning?";
    $lang['text_user_spam_filtering'] =  "Allow users to enable/disable spam filtering?";
    $lang['text_user_banned_files_checking'] =  "Allow users to enable/disable banned file attachment checks?";
    $lang['text_user_bad_header_checking'] =  "Allow users to enable/disable checks for invalid mail headers?";
    $lang['text_size_limit'] =  "Mail size limit (bytes):";
    $lang['text_oversize_policy'] =  "Oversized items should be...";
    $lang['text_admin_email'] =  "Administrator's contact e-mail address:";
    $lang['text_smtp_server'] =  "Downstream SMTP server (MTA-TX):";
    $lang['text_smtp_port'] =  "Downstream SMTP port number:";
    $lang['text_key_file'] =  "Encryption key file (optional):";
    $lang['text_newuser_template_file'] =  "Template file for e-mail sent to new users:";
    $lang['text_chart_ham_colour'] =  "Colour to use to display confirmed non-spam:";
    $lang['text_chart_spam_colour'] =  "Colour to use to display confirmed spam:";
    $lang['text_chart_virus_colour'] =  "Colour to use to display viruses:";
    $lang['text_chart_fp_colour'] =  "Colour to use to display false positives:";
    $lang['text_chart_fn_colour'] =  "Colour to use to display false negatives:";
    $lang['text_chart_suspected_ham_colour'] =  "Colour to use to display unconfirmed non-spam:";
    $lang['text_chart_suspected_spam_colour'] =  "Colour to use to display suspected spam:";
    $lang['text_chart_wl_colour'] =  "Colour to use to display whitelisted items:";
    $lang['text_chart_bl_colour'] =  "Colour to use to display blacklisted items:";
    $lang['text_chart_background_colour'] =  "Colour to use for chart backgrounds:";
    $lang['text_chart_font_colour'] =  "Colour to use for chart fonts:";
    $lang['text_chart_autogeneration_interval'] =  "Chart auto-generation interval (minutes):";
    $lang['text_expiry_period'] =  "Expiry period for quarantined mail (days):";
    $lang['text_ham_cache_expiry_period'] =  "Expiry period for cached non-spam (days):";
    $lang['text_reminder_threshold_count'] =  "E-mail reminder threshold (items):";
    $lang['text_reminder_threshold_size'] =  "E-mail reminder threshold (size):";
    $lang['text_reminder_template_file'] =  "E-mail reminder template file:";
    $lang['text_reminder_login_url'] =  "Maia login URL for e-mail reminders:";
    $lang['text_banner_title'] =  "Page-top banner title:";
    $lang['text_use_icons'] =  "Show icons in the banner toolbar?";
    $lang['text_use_logo'] =  "Show a logo in the page-top banner?";
    $lang['text_logo_file'] =  "Image file to use as the logo:";
    $lang['text_logo_alt_text'] =  "Alternative text for the logo image:";
    $lang['text_logo_url'] =  "URL the logo image should link to:";
    $lang['text_virus_info_url'] =  "URL template for virus information:";
    $lang['text_virus_lookup'] =  "Virus name rewriting rules:";
    $lang['text_none'] =  "None (no lookups)";
    $lang['text_google'] =  "Google Search";
    $lang['text_fprot'] =  "F-Prot";
    $lang['text_fsecure'] =  "F-Secure";
    $lang['text_fsecurejp'] =  "F-Secure Japan";
    $lang['text_sophos'] =  "Sophos";
    $lang['text_nod32'] =  "NOD32";
    $lang['text_norman'] =  "Norman Virus Control";
    $lang['text_trend'] =  "Trend Micro";
    $lang['text_symantec'] =  "Symantec";
    $lang['text_mcafee'] =  "McAfee VirusScan";
    $lang['text_currency_label'] =  "Currency symbol:";
    $lang['text_bandwidth_cost'] =  "Monthly bandwidth cost per gigabyte:";
    $lang['text_enable_stats_reporting'] =  "Enable the reporting of site statistics?";
    $lang['text_primary_report_server'] =  "Primary stats reporting server:";
    $lang['text_primary_report_port'] =  "Port number for primary report server:";
    $lang['text_secondary_report_server'] =  "Secondary stats reporting server:";
    $lang['text_secondary_report_port'] =  "Port number for secondary report server:";
    $lang['text_reporter_sitename'] =  "Name of your site:";
    $lang['text_reporter_username'] =  "Your site's Maia Reporter ID:";
    $lang['text_reporter_password'] =  "Your site's reporter password:";

    // Buttons
    $lang['button_submit'] =  "Update Settings";
    $lang['button_restore'] =  "Reset Form";

    // Links
    $lang['link_admin_menu'] =  "Return to the Administration Menu";
?>
