<?php
    /*
     * $Id: spam-quarantine.php 905 2005-12-27 22:47:01Z dmorton $
     *
     * MAIA MAILGUARD LICENSE v.1.0F
     *
     * Copyright 2004 by Robert LeBlanc <rjl@renaissoft.com>
     *                   David Morton   <mortonda@dgrmm.net>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */

    require_once ("core.php");
    require_once ("authcheck.php");
    require_once ("db.php");
    require_once ("display.php");
    require_once ("DB/Pager.php");  // Pear::DB_Pager
    require_once ("mime.php");
    $display_language = get_display_language($euid);
    $html_charset = get_html_charset($euid);
    require_once ("./locale/$display_language/db.php");
    require_once ("./locale/$display_language/display.php");
    require_once ("./locale/$display_language/smtp.php");
    require_once ("./locale/$display_language/mime.php"); 
    require_once ("./locale/$display_language/reportspam.php");
    require_once ("./locale/$display_language/quarantine.php");

    if (! isset($message)) {
       $message = "";
    }

    // Admins (including the superadmin) should not be looking at
    // other people's mail!
    if (!ok_to_impersonate($euid, $uid)) {
        header("Location: stats.php" . $sid);
        exit;
    }

    if (isset($_GET["offset"])) {
        $offset = $_GET["offset"];
    } else {
        $offset = 0;
    }

    foreach($_POST as $varname => $value) {
        $formVars[$varname] = trim($value);
    }
    
     if (isset($_GET["sort"])) {
  	         $sort = strtoupper(trim($_GET["sort"]));
  	         if (strlen($sort) == 2) {
  	             switch($sort[0]) {
  	                 case "X":
  	                 case "D":
  	                 case "F":
  	                 case "S":
  	                     if ($sort[1] == "A" || $sort[1] == "D") {
  	                         $update = "UPDATE maia_users SET spam_quarantine_sort = ? WHERE id = ?";
  	                         $dbh->query($update, array($sort, $euid));
  	                         header("Location: spam-quarantine.php" . $sid);
  	                         exit;
  	                     }
  	                     break;
  	                 default:
  	                     break;
  	             }
  	         } else {
  	             $sort = "";
  	         }
  	     }
  	     
  	     $sort = strtoupper(get_user_value($euid, "spam_quarantine_sort"));
  	     switch($sort[0]) {
  	         case "X":
  	             $sort_column = "score";
  	             $sortby_score = ($sort[1] == "A" ? "xd" : "xa");
  	             $sortby_date = "da";
  	             $sortby_from = "fa";
  	             $sortby_subject = "sa";
  	             break;
  	         case "D":
  	             $sort_column = "received_date";
  	             $sortby_score = "xa";
  	             $sortby_date = ($sort[1] == "A" ? "dd" : "da");
  	             $sortby_from = "fa";
  	             $sortby_subject = "sa";
  	             break;
  	         case "F":
  	             $sort_column = "sender_email";
  	             $sortby_score = "xa";
  	             $sortby_date = "da";
  	             $sortby_from = ($sort[1] == "A" ? "fd" : "fa");
  	             $sortby_subject = "sa";
  	             break;
  	         case "S":
  	             $sort_column = "subject";
  	             $sortby_score = "xa";
  	             $sortby_date = "da";
  	             $sortby_from = "fa";
  	             $sortby_subject = ($sort[1] == "A" ? "sd" : "sa");
  	             break;
  	         default:
  	             $sort_column = "score";
  	             $sortby_score = "xa";
  	             $sortby_date = "da";
  	             $sortby_from = "fa";
  	             $sortby_subject = "sa";
  	     }
  	     if ($sort[1] == "D") {
  	         $sort_order = "DESC";
  	     } else {
  	         $sort_order = "ASC";
  	     }
    
    

    // Get a list of all the (S)uspected spam items with this user's
    // ID in the recipient list, and sort it in ascending
    // order by spam score.
    $item_select = "SELECT maia_mail.id, maia_mail.received_date, maia_mail.score, " .
                     "maia_mail.sender_email, maia_mail.subject, maia_mail.envelope_to " .
              "FROM maia_mail, maia_mail_recipients " .
              "WHERE maia_mail.id = maia_mail_recipients.mail_id " .
              "AND maia_mail_recipients.type = 'S' " .
              "AND maia_mail_recipients.recipient_id = ? " .
              "ORDER BY maia_mail." . $sort_column . " " . $sort_order;

    if (isset($_POST["confirm"])) {
    	$confirmed = 0;
    	$rescued = 0;
    	$deleted = 0;
        $sth = $dbh->query($item_select, array($euid));
        while ($row = $sth->fetchRow())
        {
            $mail_id = $row["id"];

            if (!empty($formVars["item_" . $mail_id ])) {

            	if ($formVars["item_" . $mail_id] == "spam") {

                    confirm_spam($euid, $mail_id);
                    $confirmed++;

                } elseif ($formVars["item_" . $mail_id] == "ham") {

                    $result = rescue_item($euid, $mail_id);
                    if (strncmp($result, "2", 1) == 0) {
                        $rescued++;
                    } else {
                        $message .= $result . "\n";
                    }

                } elseif ($formVars["item_" . $mail_id] == "delete") {

                    delete_mail_reference($euid, $mail_id);
                    $deleted++;

                }
            }
        }
        $sth->free();
        update_mail_stats($euid, "suspected_spam");
        if ($confirmed > 0) {
            $message .= sprintf($lang['text_spam_confirmed'], $confirmed) . ".<br>";
        }
        if ($deleted > 0) {
            $message .= sprintf($lang['text_spam_deleted'], $deleted) . ".<br>";
        }
        if ($rescued > 0) {
            $message .= sprintf($lang['text_spam_rescued'], $rescued) . ".<br>";
        }
        
    }

    $magic_quotes = get_magic_quotes_gpc();
    
    require_once ("smarty.php");
    $smarty->assign("message", $message);
    $smarty->assign("banner_title","Spam Quarantine");

    $smarty->assign("msid", $msid);
    $smarty->assign("lang", $lang);
    
    $smarty->assign("sortby_score",$sortby_score);
	$smarty->assign("sortby_date", $sortby_date);
	$smarty->assign("sortby_from", $sortby_from);
	$smarty->assign("sortby_subject", $sortby_subject);
    
   $sth = $dbh->query($item_select, array($euid));
   if ($sth->numRows() > 0)
   {
      $select2 = "SELECT email FROM users WHERE maia_user_id = ?";
      $sth2 = $dbh->query($select2, array($euid));
      while ($row2 = $sth2->fetchrow()) {
          $personal_addresses[] = $row2["email"];
      }
      $sth2->free();
      $personal_addresses = array_flip($personal_addresses);
      $domain_default = is_a_domain_default_user($euid);
      $need_to = (count($personal_addresses) > 1 || $domain_default);
      if ($need_to) {
          $cols = 8;
      } else {
          $cols = 7;
      }
      $per_page = get_user_value($euid, "items_per_page");
      $pager = new DB_Pager($sth, $offset, $per_page);
      $data = $pager->build();
      $maxspamid = 0;

	$smarty->assign("cols", $cols);
	$smarty->assign("data", $data);
	$smarty->assign("offset", $offset);

    if ($sth->numrows() == 1) {
        $item_text = $lang['text_item'];
    } else {
        $item_text = $lang['text_items'];
    }
    $smarty->assign("need_to", $need_to);
	$count = 0;
	$rows = array();
 
      while ($row = $pager->fetchrow())
      {
          if ($row["id"] > $maxspamid) {
              $maxspamid = $row["id"];
          }
          $rows[$count]['id'] = $row['id'];
          $rows[$count]['score'] = sprintf("%0.1f", $row["score"]);
          $rows[$count]['received_date'] = $row["received_date"];
          $rows[$count]['sender_email'] = $magic_quotes ? stripslashes($row["sender_email"]) : $row["sender_email"];
          if ($need_to) {
            $to_list = explode(" ", $row["envelope_to"]);
              $my_recipients = array();
        	   foreach ($to_list as $recipient) {
        		   if (isset($personal_addresses[$recipient]) || $domain_default) {
        		      $my_recipients[] = $recipient;
        		   }
             }
             $rows[$count]['recipient_email'] = implode("<br>", $my_recipients);
          }
         $subject = trim(htmlentities($magic_quotes ? stripslashes($row['subject']) : $row['subject']));
         if ($subject == "") {
            $subject = "(" . $lang['text_no_subject'] . ")";
         }else{
        	     $subject = decode_header($subject, $html_charset);
         }
         $rows[$count]['subject'] = $subject;
            $count++;
   }
   $sth->free();

   $smarty->assign("row", $rows);
   $smarty->assign("maxspamid", $maxspamid);
} else {
	$_SESSION["message"] .= $message;
	header("Location: welcome.php" . $sid);
    exit;
}

$smarty->display("spam-quarantine.tpl");
