<?php
    /*
     * $Id$
     *
     * MAIA MAILGUARD LICENSE v.1.0
     *
     * Copyright 2005 by Robert LeBlanc <rjl@renaissoft.com>
     *                   David Morton   <mortonda@dgrmm.net>
     * All rights reserved.
     *
     * PREAMBLE
     *
     * This License is designed for users of Maia Mailguard
     * ("the Software") who wish to support the Maia Mailguard project by
     * leaving "Maia Mailguard" branding information in the HTML output
     * of the pages generated by the Software, and providing links back
     * to the Maia Mailguard home page.  Users who wish to remove this
     * branding information should contact the copyright owner to obtain
     * a Rebranding License.
     *
     * DEFINITION OF TERMS
     *
     * The "Software" refers to Maia Mailguard, including all of the
     * associated PHP, Perl, and SQL scripts, documentation files, graphic
     * icons and logo images.
     *
     * GRANT OF LICENSE
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *
     * 2. Redistributions in binary form must reproduce the above copyright
     *    notice, this list of conditions and the following disclaimer in the
     *    documentation and/or other materials provided with the distribution.
     *
     * 3. The end-user documentation included with the redistribution, if
     *    any, must include the following acknowledgment:
     *
     *    "This product includes software developed by Robert LeBlanc
     *    <rjl@renaissoft.com>."
     *
     *    Alternately, this acknowledgment may appear in the software itself,
     *    if and wherever such third-party acknowledgments normally appear.
     *
     * 4. At least one of the following branding conventions must be used:
     *
     *    a. The Maia Mailguard logo appears in the page-top banner of
     *       all HTML output pages in an unmodified form, and links
     *       directly to the Maia Mailguard home page; or
     *
     *    b. The "Powered by Maia Mailguard" graphic appears in the HTML
     *       output of all gateway pages that lead to this software,
     *       linking directly to the Maia Mailguard home page; or
     *
     *    c. A separate Rebranding License is obtained from the copyright
     *       owner, exempting the Licensee from 4(a) and 4(b), subject to
     *       the additional conditions laid out in that license document.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
     * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
     * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
     * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
     * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
     * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
     * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */

    // Set up and authenticate session based on token.  If the values are 
    // provided, force session to be the owner of the token, regardless of 
    // previous session information.
    session_start();
    if (isset($_GET["token"]) && isset($_GET["id"])) {
      if (!session_is_registered("uid")  || 
          !session_is_registered("euid") ||
          !$_GET["id"] == $_SESSION['euid'] ||
          time() > $_SESSION["timeout"]) {  //if session is timed out, re-authenticate the session.
        header("Location: xlogin.php?action=viewer.php&" . $_SERVER["QUERY_STRING"]);
        exit();
      }
      $token = trim($_GET["token"]);
    } else {
       header("Location: login.php");
       exit;
    }
    require_once ("config.php");
    require_once ("display.php");
    require_once ("db.php");
    require_once ("authcheck.php");
    require_once ("mime.php");
    require_once ("Mail/mimeDecode.php");  // PEAR::Mail::mimeDecode.php
    require_once ("encrypt.php");
    $display_language = get_display_language($euid);
    $html_charset = get_html_charset($euid);
    require_once ("./locale/$display_language/display.php");
    require_once ("./locale/$display_language/db.php");
    require_once ("./locale/$display_language/mime.php");
    require_once ("./locale/$display_language/viewmail.php");
    require_once ("./locale/$display_language/xlogin.php");

    require_once ("smarty.php");

    
    if (isset($_GET["type"])) {
       $type = trim($_GET["type"]);
    } else {
       $type = "spam";
    }

    $smarty->assign("type", $type);
    $raw = false;
    $smarty->assign("raw", $raw);
    if ($raw) {
        $bodyclass = "rawmail";
    } else {
    	$bodyclass = "decodedmail";
    }

    $use_icons = (get_config_value("use_icons") == "Y");

   // Open and read the gzipped mail file, and display the
   // contents for basic MIME types:
   //
   //    text/plain
   //    text/html
   //
   // Decoding is provided for common formats:
   //
   //    base64
   //    quoted-printable
   //    8bit
   //    7bit
   //

   $select = "SELECT maia_mail.contents, maia_mail.id " .
                 "FROM maia_mail, maia_mail_recipients " .
                 "WHERE maia_mail.id = maia_mail_recipients.mail_id " .
                 "AND maia_mail_recipients.token = ? " .
                 "AND SUBSTRING(maia_mail_recipients.token, 1, 7) <> 'expired'";

   $sth = $dbh->query($select, array($token));
   if (DB::isError($sth)) {
    trigger_error($sth->getMessage());
   }
   if ($row = $sth->fetchrow()) {
       $contents = $row["contents"];
       $id = $row["id"];
       if (extension_loaded('mcrypt')) {
          if (text_is_encrypted($contents)) {
       	    $key = get_encryption_key();
            $contents = decrypt_text($key, $contents);
          }
       }
       $smarty->assign("id", $id);
       $smarty->assign("spamreport_rows", display_spam_report($id));

       if (!$raw) {

          // Try to decode the mail and display all of its parts.
          $mail = new Mail_mimeDecode((get_magic_quotes_gpc() ? 
                          stripslashes($contents) : $contents));
          $args['include_bodies'] = true;
          $args['decode_bodies'] = true;
          $args['decode_headers'] = true;
          $structure = $mail->decode($args);
          $smarty->assign("message", display_parts($structure));
       } else {

          // Strip out the X-Envelope-To: header for privacy
          $contents = preg_replace("/X-Envelope-To:(.*)\n/i", "", $contents);

          // Dump the raw contents of the e-mail, making sure to
          // escape any HTML tags it might contain, so the raw source
          // gets displayed.
         $smarty->assign("message", "<pre>" . htmlentities(wordwrap($contents, 70)) . "</pre>");


       }
       $smarty->assign("error",false);  //need to assign something so smarty doesn't complain.
   } else {
       $smarty->assign("error",$lang['invalid_token']);
       // Error!  Mail doesn't belong to this user!
   }
   $sth->free();

$returnroutes = array ( 'spam' => "spam-quarantine.php",
              'ham' => "ham-cache.php",
              'virus' => "virus-quarantine.php",
              'banned_file' => "attachment-quarantine.php",
              'bad_header' => "header-quarantine.php"
              );
 
  $smarty->assign("return_route", $returnroutes[$type]);
   $smarty->display("viewmail.tpl");
?>